package com.loafle.bridge.discoveryzone;

import com.loafle.bridge.Application;
import org.junit.After;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by snoop on 16. 11. 16.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = Application.class)
public class DiscoveryZoneRepositoryTest {

    @Autowired
    DiscoveryZoneRepository discoveryZoneRepository;



//    @Before
    public void setUp() throws Exception {
        DiscoveryZone discoveryZone = new DiscoveryZone();


        String cidr = "827452358680";
        String ip = "3232235983";


        discoveryZone.setCidr(Long.parseLong(cidr));
        discoveryZone.setIp(Long.parseLong(ip));

        discoveryZoneRepository.save(discoveryZone);
    }

    @After
    public void tearDown() throws Exception {

    }

    @Test
    public void InsertZone() throws Exception {

        DiscoveryZone discoveryZone = new DiscoveryZone();


        String cidr = "827452358680";
        String ip = "3232235983";


        discoveryZone.setCidr(Long.parseLong(cidr));
        discoveryZone.setIp(Long.parseLong(ip));

        discoveryZoneRepository.save(discoveryZone);




    }

    @Test
//    @Transactional
    public void InsertHostHistory() throws Exception {

        DiscoveryZone zone = discoveryZoneRepository.findAll().get(0);

        HostScanHistory hostScanHistory = null;

        System.out.println("!!!!!!!!!!!!!!!!!!!!!= " + zone.getCidr());

        List<HostScanHistory> hostScanHistories = new ArrayList<HostScanHistory>();

        String ip = "3232235983";

        for( int indexI = 0 ; indexI < 5; ++indexI) {

            hostScanHistory = new HostScanHistory();

            hostScanHistory.setIp(Long.parseLong(ip));

            hostScanHistory.setCreateDate(new Date());
            hostScanHistory.setSendDate(new Date());
            hostScanHistory.setResultDate(new Date());
            hostScanHistory.setDescription("hgihihihih");

            hostScanHistory.setResultType(ResultType.Success);
            hostScanHistory.setZone(zone);


            hostScanHistories.add(hostScanHistory);
        }


        zone.setHistories(hostScanHistories);
        discoveryZoneRepository.save(zone);


//        discoveryZoneRepository.flush();
        
        DiscoveryZone zzzz = discoveryZoneRepository.findOne(zone.getId());

//        if(zzzz.getHostScanHistories() != null && zzzz.getHostScanHistories().size() > 0) {
//            System.out.println("zzzz. = " + zzzz.getHostScanHistories().size());
//        }
//        else {
//            System.out.println("TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT");
//        }

    }

}